diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-phy.cc ns-3.43/src/wifi/model/he/he-phy.cc
--- ns-3.42/src/wifi/model/he/he-phy.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-phy.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rediet <getachew.redieteab@orange.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy and
@@ -29,10 +18,10 @@
 #include "ns3/interference-helper.h"
 #include "ns3/log.h"
 #include "ns3/simulator.h"
+#include "ns3/spectrum-wifi-phy.h"
 #include "ns3/sta-wifi-mac.h"
 #include "ns3/vht-configuration.h"
 #include "ns3/wifi-net-device.h"
-#include "ns3/wifi-phy.h"
 #include "ns3/wifi-psdu.h"
 #include "ns3/wifi-utils.h"
 
@@ -238,13 +227,13 @@
 Time
 HePhy::GetSigBDuration(const WifiTxVector& txVector) const
 {
-    if (auto sigBSize = GetSigBSize(txVector); sigBSize > 0)
+    if (const auto sigBSize = GetSigBSize(txVector); sigBSize > 0)
     {
-        auto symbolDuration = MicroSeconds(4);
+        const auto symbolDuration = MicroSeconds(4);
         // Number of data bits per symbol
-        auto ndbps =
-            GetSigBMode(txVector).GetDataRate(20, 800, 1) * symbolDuration.GetNanoSeconds() / 1e9;
-        auto numSymbols = ceil((sigBSize) / ndbps);
+        const auto ndbps =
+            GetSigBMode(txVector).GetDataRate(20) * symbolDuration.GetNanoSeconds() / 1e9;
+        const auto numSymbols = ceil((sigBSize) / ndbps);
 
         return FemtoSeconds(static_cast<uint64_t>(numSymbols * symbolDuration.GetFemtoSeconds()));
     }
@@ -258,8 +247,8 @@
 Time
 HePhy::GetValidPpduDuration(Time ppduDuration, const WifiTxVector& txVector, WifiPhyBand band)
 {
-    Time tSymbol = NanoSeconds(12800 + txVector.GetGuardInterval());
-    Time preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
+    const auto tSymbol = GetSymbolDuration(txVector.GetGuardInterval());
+    const auto preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
     uint8_t sigExtension = (band == WIFI_PHY_BAND_2_4GHZ ? 6 : 0);
     uint32_t nSymbols =
         floor(static_cast<double>((ppduDuration - preambleDuration).GetNanoSeconds() -
@@ -329,16 +318,17 @@
 Time
 HePhy::GetSymbolDuration(const WifiTxVector& txVector) const
 {
-    uint16_t gi = txVector.GetGuardInterval();
+    const auto guardInterval = txVector.GetGuardInterval();
+    [[maybe_unused]] const auto gi = guardInterval.GetNanoSeconds();
     NS_ASSERT(gi == 800 || gi == 1600 || gi == 3200);
-    return GetSymbolDuration(NanoSeconds(gi));
+    return GetSymbolDuration(guardInterval);
 }
 
 void
 HePhy::SetTrigVector(const WifiTxVector& trigVector, Time validity)
 {
     NS_LOG_FUNCTION(this << trigVector << validity);
-    NS_ASSERT_MSG(trigVector.GetGuardInterval() > 800,
+    NS_ASSERT_MSG(trigVector.GetGuardInterval().GetNanoSeconds() > 800,
                   "Invalid guard interval " << trigVector.GetGuardInterval());
     if (auto mac = m_wifiPhy->GetDevice()->GetMac(); mac && mac->GetTypeOfStation() != AP)
     {
@@ -378,7 +368,7 @@
         {
             // AP or STA has already received non-HE portion, switch to HE portion, and schedule
             // reception of payload (will be canceled for STAs by StartPayload)
-            bool hePortionStarted = !m_beginMuPayloadRxEvents.empty();
+            const auto hePortionStarted = !m_beginMuPayloadRxEvents.empty();
             NS_LOG_INFO("Switch to HE portion (already started? "
                         << (hePortionStarted ? "Y" : "N") << ") "
                         << "and schedule payload reception in "
@@ -612,9 +602,10 @@
     NS_LOG_FUNCTION(this << *event << status);
     // Notify end of SIG-A (in all cases)
     const auto& txVector = event->GetPpdu()->GetTxVector();
-    HeSigAParameters params;
-    params.rssiW = GetRxPowerWForPpdu(event);
-    params.bssColor = txVector.GetBssColor();
+    HeSigAParameters params{
+        .rssi = WToDbm(GetRxPowerForPpdu(event)),
+        .bssColor = txVector.GetBssColor(),
+    };
     NotifyEndOfHeSigA(params); // if OBSS_PD CCA_RESET, set power restriction first and wait till
                                // field is processed before switching to IDLE
 
@@ -757,9 +748,9 @@
     }
 
     const auto& txVector = ppdu->GetTxVector();
-    uint16_t staId = GetStaId(ppdu);
-    WifiMode txMode = txVector.GetMode(staId);
-    uint8_t nss = txVector.GetNssMax();
+    const auto staId = GetStaId(ppdu);
+    const auto txMode = txVector.GetMode(staId);
+    auto nss = txVector.GetNssMax();
     if (txVector.IsDlMu())
     {
         NS_ASSERT(txVector.GetModulationClass() >= WIFI_MOD_CLASS_HE);
@@ -842,7 +833,7 @@
     else
     {
         NS_LOG_DEBUG("Receiving PSDU in HE TB PPDU");
-        uint16_t staId = GetStaId(ppdu);
+        const auto staId = GetStaId(ppdu);
         m_signalNoiseMap.insert({{ppdu->GetUid(), staId}, SignalNoiseDbm()});
         m_statusPerMpduMap.insert({{ppdu->GetUid(), staId}, std::vector<bool>()});
         // for HE TB PPDUs, ScheduleEndOfMpdus and EndReceive are scheduled by
@@ -934,7 +925,7 @@
 {
     NS_LOG_FUNCTION(this << event);
     Ptr<const WifiPpdu> ppdu = event->GetPpdu();
-    const RxPowerWattPerChannelBand& rxPowersW = event->GetRxPowerWPerBand();
+    const RxPowerWattPerChannelBand& rxPowersW = event->GetRxPowerPerBand();
     // The total RX power corresponds to the maximum over all the bands.
     // Only perform this computation if the result needs to be logged.
     auto it = rxPowersW.end();
@@ -957,20 +948,20 @@
     NS_ASSERT(itEvent != m_beginMuPayloadRxEvents.end() && itEvent->second.IsExpired());
     m_beginMuPayloadRxEvents.erase(itEvent);
 
-    Time payloadDuration =
+    auto payloadDuration =
         ppdu->GetTxDuration() - CalculatePhyPreambleAndHeaderDuration(ppdu->GetTxVector());
-    Ptr<const WifiPsdu> psdu = GetAddressedPsduInPpdu(ppdu);
+    auto psdu = GetAddressedPsduInPpdu(ppdu);
     ScheduleEndOfMpdus(event);
     m_endRxPayloadEvents.push_back(
         Simulator::Schedule(payloadDuration, &HePhy::EndReceivePayload, this, event));
-    uint16_t staId = GetStaId(ppdu);
+    const auto staId = GetStaId(ppdu);
     m_signalNoiseMap.insert({{ppdu->GetUid(), staId}, SignalNoiseDbm()});
     m_statusPerMpduMap.insert({{ppdu->GetUid(), staId}, std::vector<bool>()});
     // Notify the MAC about the start of a new HE TB PPDU, so that it can reschedule the timeout
     NotifyPayloadBegin(ppdu->GetTxVector(), payloadDuration);
 }
 
-std::pair<uint16_t, WifiSpectrumBandInfo>
+std::pair<MHz_u, WifiSpectrumBandInfo>
 HePhy::GetChannelWidthAndBand(const WifiTxVector& txVector, uint16_t staId) const
 {
     if (txVector.IsMu())
@@ -989,7 +980,7 @@
 {
     NS_ASSERT(txVector.IsMu());
     HeRu::RuSpec ru = txVector.GetRu(staId);
-    uint16_t channelWidth = txVector.GetChannelWidth();
+    const auto channelWidth = txVector.GetChannelWidth();
     NS_ASSERT(channelWidth <= m_wifiPhy->GetChannelWidth());
     HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup(
         channelWidth,
@@ -997,13 +988,21 @@
         ru.GetPhyIndex(channelWidth, m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20)));
     // for a TX spectrum, the guard bandwidth is a function of the transmission channel width
     // and the spectrum width equals the transmission channel width (hence bandIndex equals 0)
-    auto indices = ConvertHeRuSubcarriers(channelWidth,
-                                          GetGuardBandwidth(channelWidth),
-                                          m_wifiPhy->GetSubcarrierSpacing(),
-                                          {group.front().first, group.back().second},
-                                          0);
-    auto frequencies = m_wifiPhy->ConvertIndicesToFrequencies(indices);
-    return {indices, frequencies};
+    const auto indices = ConvertHeRuSubcarriers(channelWidth,
+                                                GetGuardBandwidth(channelWidth),
+                                                m_wifiPhy->GetOperatingChannel().GetFrequencies(),
+                                                m_wifiPhy->GetChannelWidth(),
+                                                m_wifiPhy->GetSubcarrierSpacing(),
+                                                {group.front().first, group.back().second},
+                                                0);
+    WifiSpectrumBandInfo ruBandForTx{};
+    for (const auto& indicesPerSegment : indices)
+    {
+        ruBandForTx.indices.emplace_back(indicesPerSegment);
+        ruBandForTx.frequencies.emplace_back(
+            m_wifiPhy->ConvertIndicesToFrequencies(indicesPerSegment));
+    }
+    return ruBandForTx;
 }
 
 WifiSpectrumBandInfo
@@ -1011,7 +1010,7 @@
 {
     NS_ASSERT(txVector.IsMu());
     HeRu::RuSpec ru = txVector.GetRu(staId);
-    uint16_t channelWidth = txVector.GetChannelWidth();
+    const auto channelWidth = txVector.GetChannelWidth();
     NS_ASSERT(channelWidth <= m_wifiPhy->GetChannelWidth());
     HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup(
         channelWidth,
@@ -1019,25 +1018,33 @@
         ru.GetPhyIndex(channelWidth, m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20)));
     // for an RX spectrum, the guard bandwidth is a function of the operating channel width
     // and the spectrum width equals the operating channel width
-    auto indices = ConvertHeRuSubcarriers(
+    const auto indices = ConvertHeRuSubcarriers(
         channelWidth,
         GetGuardBandwidth(m_wifiPhy->GetChannelWidth()),
+        m_wifiPhy->GetOperatingChannel().GetFrequencies(),
+        m_wifiPhy->GetChannelWidth(),
         m_wifiPhy->GetSubcarrierSpacing(),
         {group.front().first, group.back().second},
         m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(channelWidth));
-    auto frequencies = m_wifiPhy->ConvertIndicesToFrequencies(indices);
-    return {indices, frequencies};
+    WifiSpectrumBandInfo ruBandForRx{};
+    for (const auto& indicesPerSegment : indices)
+    {
+        ruBandForRx.indices.emplace_back(indicesPerSegment);
+        ruBandForRx.frequencies.emplace_back(
+            m_wifiPhy->ConvertIndicesToFrequencies(indicesPerSegment));
+    }
+    return ruBandForRx;
 }
 
 WifiSpectrumBandInfo
 HePhy::GetNonOfdmaBand(const WifiTxVector& txVector, uint16_t staId) const
 {
     NS_ASSERT(txVector.IsUlMu() && (txVector.GetModulationClass() >= WIFI_MOD_CLASS_HE));
-    uint16_t channelWidth = txVector.GetChannelWidth();
+    const auto channelWidth = txVector.GetChannelWidth();
     NS_ASSERT(channelWidth <= m_wifiPhy->GetChannelWidth());
 
     HeRu::RuSpec ru = txVector.GetRu(staId);
-    uint16_t nonOfdmaWidth = GetNonOfdmaWidth(ru);
+    const auto nonOfdmaWidth = GetNonOfdmaWidth(ru);
 
     // Find the RU that encompasses the non-OFDMA part of the HE TB PPDU for the STA-ID
     HeRu::RuSpec nonOfdmaRu =
@@ -1048,17 +1055,25 @@
         nonOfdmaRu.GetRuType(),
         nonOfdmaRu.GetPhyIndex(channelWidth,
                                m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20)));
-    auto indices = ConvertHeRuSubcarriers(
+    const auto indices = ConvertHeRuSubcarriers(
         channelWidth,
         GetGuardBandwidth(m_wifiPhy->GetChannelWidth()),
+        m_wifiPhy->GetOperatingChannel().GetFrequencies(),
+        m_wifiPhy->GetChannelWidth(),
         m_wifiPhy->GetSubcarrierSpacing(),
         {groupPreamble.front().first, groupPreamble.back().second},
         m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(channelWidth));
-    auto frequencies = m_wifiPhy->ConvertIndicesToFrequencies(indices);
-    return {indices, frequencies};
+    WifiSpectrumBandInfo nonOfdmaBand{};
+    for (const auto& indicesPerSegment : indices)
+    {
+        nonOfdmaBand.indices.emplace_back(indicesPerSegment);
+        nonOfdmaBand.frequencies.emplace_back(
+            m_wifiPhy->ConvertIndicesToFrequencies(indicesPerSegment));
+    }
+    return nonOfdmaBand;
 }
 
-uint16_t
+MHz_u
 HePhy::GetNonOfdmaWidth(HeRu::RuSpec ru) const
 {
     if (ru.GetRuType() == HeRu::RU_26_TONE && ru.GetIndex() == 19)
@@ -1067,7 +1082,7 @@
         // any 20 MHz channel, but only by an 80 MHz channel
         return 80;
     }
-    return std::max<uint16_t>(HeRu::GetBandwidth(ru.GetRuType()), 20);
+    return std::max<MHz_u>(HeRu::GetBandwidth(ru.GetRuType()), 20);
 }
 
 uint64_t
@@ -1076,10 +1091,10 @@
     return m_currentMuPpduUid;
 }
 
-uint16_t
+MHz_u
 HePhy::GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const
 {
-    uint16_t channelWidth = OfdmPhy::GetMeasurementChannelWidth(ppdu);
+    auto channelWidth = OfdmPhy::GetMeasurementChannelWidth(ppdu);
     /**
      * The PHY shall not issue a PHY-RXSTART.indication primitive in response to a PPDU that does
      * not overlap the primary channel unless the PHY at an AP receives the HE TB PPDU solicited by
@@ -1094,7 +1109,7 @@
     return channelWidth;
 }
 
-double
+dBm_u
 HePhy::GetCcaThreshold(const Ptr<const WifiPpdu> ppdu, WifiChannelListType channelType) const
 {
     if (!ppdu)
@@ -1112,9 +1127,9 @@
         return VhtPhy::GetCcaThreshold(ppdu, channelType);
     }
 
-    const uint16_t ppduBw = ppdu->GetTxVector().GetChannelWidth();
-    double obssPdLevel = m_obssPdAlgorithm->GetObssPdLevel();
-    uint16_t bw = ppduBw;
+    const auto ppduBw = ppdu->GetTxVector().GetChannelWidth();
+    auto obssPdLevel = m_obssPdAlgorithm->GetObssPdLevel();
+    auto bw = ppduBw;
     while (bw > 20)
     {
         obssPdLevel += 3;
@@ -1200,15 +1215,15 @@
          * aCCATime after the signal starts and shall continue to indicate the 20 MHz subchannel is
          * busy while the threshold continues to be exceeded.
          */
-        double ccaThresholdDbm = -62;
-        Time delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThresholdDbm, band);
+        dBm_u ccaThreshold = -62;
+        auto delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, band);
 
         if (ppdu)
         {
-            const uint16_t subchannelMinFreq =
+            const MHz_u subchannelMinFreq =
                 m_wifiPhy->GetFrequency() - (m_wifiPhy->GetChannelWidth() / 2) + (index * 20);
-            const uint16_t subchannelMaxFreq = subchannelMinFreq + 20;
-            const uint16_t ppduBw = ppdu->GetTxVector().GetChannelWidth();
+            const MHz_u subchannelMaxFreq = subchannelMinFreq + 20;
+            const auto ppduBw = ppdu->GetTxVector().GetChannelWidth();
 
             if (ppduBw <= m_wifiPhy->GetChannelWidth() &&
                 ppdu->DoesOverlapChannel(subchannelMinFreq, subchannelMaxFreq))
@@ -1218,7 +1233,7 @@
                 {
                     obssPdLevel = m_obssPdAlgorithm->GetObssPdLevel();
                 }
-                switch (ppduBw)
+                switch (static_cast<uint16_t>(ppduBw))
                 {
                 case 20:
                 case 22:
@@ -1228,7 +1243,7 @@
                      * The PHY shall indicate that the 20 MHz subchannel is busy with > 90%
                      * probability within a period aCCAMidTime.
                      */
-                    ccaThresholdDbm =
+                    ccaThreshold =
                         obssPdLevel.has_value() ? std::max(-72.0, obssPdLevel.value()) : -72.0;
                     band = m_wifiPhy->GetBand(20, index);
                     break;
@@ -1239,7 +1254,7 @@
                      * the receiver's antenna(s) is present. The PHY shall indicate that the 20 MHz
                      * subchannel is busy with > 90% probability within a period aCCAMidTime.
                      */
-                    ccaThresholdDbm =
+                    ccaThreshold =
                         obssPdLevel.has_value() ? std::max(-72.0, obssPdLevel.value() + 3) : -72.0;
                     band = m_wifiPhy->GetBand(40, std::floor(index / 2));
                     break;
@@ -1250,7 +1265,7 @@
                      * receiver's antenna(s) is present. The PHY shall indicate that the 20 MHz
                      * subchannel is busy with > 90% probability within a period aCCAMidTime.
                      */
-                    ccaThresholdDbm =
+                    ccaThreshold =
                         obssPdLevel.has_value() ? std::max(-69.0, obssPdLevel.value() + 6) : -69.0;
                     band = m_wifiPhy->GetBand(80, std::floor(index / 4));
                     break;
@@ -1261,7 +1276,7 @@
                     NS_ASSERT_MSG(false, "Invalid channel width: " << ppduBw);
                 }
             }
-            Time ppduCcaDuration = GetDelayUntilCcaEnd(ccaThresholdDbm, band);
+            const auto ppduCcaDuration = GetDelayUntilCcaEnd(ccaThreshold, band);
             delayUntilCcaEnd = std::max(delayUntilCcaEnd, ppduCcaDuration);
         }
         per20MhzDurations.push_back(delayUntilCcaEnd);
@@ -1310,23 +1325,32 @@
 }
 
 Ptr<SpectrumValue>
-HePhy::GetTxPowerSpectralDensity(double txPowerW, Ptr<const WifiPpdu> ppdu) const
+HePhy::GetTxPowerSpectralDensity(Watt_u txPower, Ptr<const WifiPpdu> ppdu) const
 {
     auto hePpdu = DynamicCast<const HePpdu>(ppdu);
     NS_ASSERT(hePpdu);
     HePpdu::TxPsdFlag flag = hePpdu->GetTxPsdFlag();
-    return GetTxPowerSpectralDensity(txPowerW, ppdu, flag);
+    return GetTxPowerSpectralDensity(txPower, ppdu, flag);
 }
 
 Ptr<SpectrumValue>
-HePhy::GetTxPowerSpectralDensity(double txPowerW,
+HePhy::GetTxPowerSpectralDensity(Watt_u txPower,
                                  Ptr<const WifiPpdu> ppdu,
                                  HePpdu::TxPsdFlag flag) const
 {
     const auto& txVector = ppdu->GetTxVector();
-    uint16_t centerFrequency = GetCenterFrequencyForChannelWidth(txVector);
-    uint16_t channelWidth = txVector.GetChannelWidth();
-    NS_LOG_FUNCTION(this << centerFrequency << channelWidth << txPowerW << txVector);
+    const auto& centerFrequencies = ppdu->GetTxCenterFreqs();
+    auto channelWidth = txVector.GetChannelWidth();
+    auto printFrequencies = [](const std::vector<MHz_u>& v) {
+        std::stringstream ss;
+        for (const auto& centerFrequency : v)
+        {
+            ss << centerFrequency << " ";
+        }
+        return ss.str();
+    };
+    NS_LOG_FUNCTION(this << printFrequencies(centerFrequencies) << channelWidth << txPower
+                         << txVector);
     const auto& puncturedSubchannels = txVector.GetInactiveSubchannels();
     if (!puncturedSubchannels.empty())
     {
@@ -1344,14 +1368,13 @@
         if (flag == HePpdu::PSD_NON_HE_PORTION)
         {
             // non-HE portion is sent only on the 20 MHz channels covering the RU
-            const uint16_t staId = GetStaId(ppdu);
-            centerFrequency = GetCenterFrequencyForNonHePart(txVector, staId);
-            const uint16_t ruWidth = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
+            const auto staId = GetStaId(ppdu);
+            const auto ruWidth = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
             channelWidth = (ruWidth < 20) ? 20 : ruWidth;
             return WifiSpectrumValueHelper::CreateDuplicated20MhzTxPowerSpectralDensity(
-                centerFrequency,
+                GetCenterFrequenciesForNonHePart(ppdu, staId),
                 channelWidth,
-                txPowerW,
+                txPower,
                 GetGuardBandwidth(channelWidth),
                 std::get<0>(txMaskRejectionParams),
                 std::get<1>(txMaskRejectionParams),
@@ -1362,9 +1385,9 @@
         {
             const auto band = GetRuBandForTx(txVector, GetStaId(ppdu)).indices;
             return WifiSpectrumValueHelper::CreateHeMuOfdmTxPowerSpectralDensity(
-                centerFrequency,
+                centerFrequencies,
                 channelWidth,
-                txPowerW,
+                txPower,
                 GetGuardBandwidth(channelWidth),
                 band);
         }
@@ -1373,9 +1396,9 @@
         if (flag == HePpdu::PSD_NON_HE_PORTION)
         {
             return WifiSpectrumValueHelper::CreateDuplicated20MhzTxPowerSpectralDensity(
-                centerFrequency,
+                centerFrequencies,
                 channelWidth,
-                txPowerW,
+                txPower,
                 GetGuardBandwidth(channelWidth),
                 std::get<0>(txMaskRejectionParams),
                 std::get<1>(txMaskRejectionParams),
@@ -1385,9 +1408,9 @@
         else
         {
             return WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(
-                centerFrequency,
+                centerFrequencies,
                 channelWidth,
-                txPowerW,
+                txPower,
                 GetGuardBandwidth(channelWidth),
                 std::get<0>(txMaskRejectionParams),
                 std::get<1>(txMaskRejectionParams),
@@ -1399,9 +1422,9 @@
     default: {
         NS_ASSERT(puncturedSubchannels.empty());
         return WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(
-            centerFrequency,
+            centerFrequencies,
             channelWidth,
-            txPowerW,
+            txPower,
             GetGuardBandwidth(channelWidth),
             std::get<0>(txMaskRejectionParams),
             std::get<1>(txMaskRejectionParams),
@@ -1410,24 +1433,25 @@
     }
 }
 
-uint16_t
-HePhy::GetCenterFrequencyForNonHePart(const WifiTxVector& txVector, uint16_t staId) const
+std::vector<MHz_u>
+HePhy::GetCenterFrequenciesForNonHePart(Ptr<const WifiPpdu> ppdu, uint16_t staId) const
 {
-    NS_LOG_FUNCTION(this << txVector << staId);
+    NS_LOG_FUNCTION(this << ppdu << staId);
+    const auto& txVector = ppdu->GetTxVector();
     NS_ASSERT(txVector.IsUlMu() && (txVector.GetModulationClass() >= WIFI_MOD_CLASS_HE));
-    uint16_t centerFrequency = GetCenterFrequencyForChannelWidth(txVector);
-    uint16_t currentWidth = txVector.GetChannelWidth();
+    auto centerFrequencies = ppdu->GetTxCenterFreqs();
+    const auto currentWidth = txVector.GetChannelWidth();
 
     HeRu::RuSpec ru = txVector.GetRu(staId);
-    uint16_t nonOfdmaWidth = GetNonOfdmaWidth(ru);
+    const auto nonOfdmaWidth = GetNonOfdmaWidth(ru);
     if (nonOfdmaWidth != currentWidth)
     {
         // Obtain the index of the non-OFDMA portion
         HeRu::RuSpec nonOfdmaRu =
             HeRu::FindOverlappingRu(currentWidth, ru, HeRu::GetRuType(nonOfdmaWidth));
 
-        uint16_t startingFrequency = centerFrequency - (currentWidth / 2);
-        centerFrequency =
+        const MHz_u startingFrequency = centerFrequencies.front() - (currentWidth / 2);
+        centerFrequencies.front() =
             startingFrequency +
             nonOfdmaWidth * (nonOfdmaRu.GetPhyIndex(
                                  currentWidth,
@@ -1435,7 +1459,7 @@
                              1) +
             nonOfdmaWidth / 2;
     }
-    return centerFrequency;
+    return centerFrequencies;
 }
 
 void
@@ -1449,14 +1473,14 @@
     }
     if (ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU || ppdu->GetType() == WIFI_PPDU_TYPE_DL_MU)
     {
-        auto nonHeTxPowerDbm = m_wifiPhy->GetTxPowerForTransmission(ppdu) + m_wifiPhy->GetTxGain();
+        dBm_u nonHeTxPower = m_wifiPhy->GetTxPowerForTransmission(ppdu) + m_wifiPhy->GetTxGain();
 
         // temporarily set WifiPpdu flag to PSD_HE_PORTION for correct calculation of TX power for
         // the HE portion
         auto hePpdu = DynamicCast<const HePpdu>(ppdu);
         NS_ASSERT(hePpdu);
         hePpdu->SetTxPsdFlag(HePpdu::PSD_HE_PORTION);
-        auto heTxPowerDbm = m_wifiPhy->GetTxPowerForTransmission(ppdu) + m_wifiPhy->GetTxGain();
+        dBm_u heTxPower = m_wifiPhy->GetTxPowerForTransmission(ppdu) + m_wifiPhy->GetTxGain();
         hePpdu->SetTxPsdFlag(HePpdu::PSD_NON_HE_PORTION);
 
         // non-HE portion
@@ -1464,22 +1488,22 @@
                                         ? CalculateNonHeDurationForHeTb(txVector)
                                         : CalculateNonHeDurationForHeMu(txVector);
         auto nonHeTxPowerSpectrum =
-            GetTxPowerSpectralDensity(DbmToW(nonHeTxPowerDbm), ppdu, HePpdu::PSD_NON_HE_PORTION);
+            GetTxPowerSpectralDensity(DbmToW(nonHeTxPower), ppdu, HePpdu::PSD_NON_HE_PORTION);
         Transmit(nonHePortionDuration,
                  ppdu,
-                 nonHeTxPowerDbm,
+                 nonHeTxPower,
                  nonHeTxPowerSpectrum,
                  "non-HE portion transmission");
 
         // HE portion
         auto hePortionDuration = ppdu->GetTxDuration() - nonHePortionDuration;
         auto heTxPowerSpectrum =
-            GetTxPowerSpectralDensity(DbmToW(heTxPowerDbm), ppdu, HePpdu::PSD_HE_PORTION);
+            GetTxPowerSpectralDensity(DbmToW(heTxPower), ppdu, HePpdu::PSD_HE_PORTION);
         Simulator::Schedule(nonHePortionDuration,
                             &HePhy::StartTxHePortion,
                             this,
                             ppdu,
-                            heTxPowerDbm,
+                            heTxPower,
                             heTxPowerSpectrum,
                             hePortionDuration);
     }
@@ -1491,19 +1515,19 @@
 
 void
 HePhy::StartTxHePortion(Ptr<const WifiPpdu> ppdu,
-                        double txPowerDbm,
+                        dBm_u txPower,
                         Ptr<SpectrumValue> txPowerSpectrum,
                         Time hePortionDuration)
 {
-    NS_LOG_FUNCTION(this << ppdu << txPowerDbm << hePortionDuration);
+    NS_LOG_FUNCTION(this << ppdu << txPower << hePortionDuration);
     auto hePpdu = DynamicCast<const HePpdu>(ppdu);
     NS_ASSERT(hePpdu);
     hePpdu->SetTxPsdFlag(HePpdu::PSD_HE_PORTION);
-    Transmit(hePortionDuration, ppdu, txPowerDbm, txPowerSpectrum, "HE portion transmission");
+    Transmit(hePortionDuration, ppdu, txPower, txPowerSpectrum, "HE portion transmission");
 }
 
 Time
-HePhy::CalculateTxDuration(WifiConstPsduMap psduMap,
+HePhy::CalculateTxDuration(const WifiConstPsduMap& psduMap,
                            const WifiTxVector& txVector,
                            WifiPhyBand band) const
 {
@@ -1638,17 +1662,17 @@
 }
 
 uint64_t
-HePhy::GetPhyRate(uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+HePhy::GetPhyRate(uint8_t mcsValue, MHz_u channelWidth, Time guardInterval, uint8_t nss)
 {
-    WifiCodeRate codeRate = GetCodeRate(mcsValue);
-    uint64_t dataRate = GetDataRate(mcsValue, channelWidth, guardInterval, nss);
+    const auto codeRate = GetCodeRate(mcsValue);
+    const auto dataRate = GetDataRate(mcsValue, channelWidth, guardInterval, nss);
     return HtPhy::CalculatePhyRate(codeRate, dataRate);
 }
 
 uint64_t
 HePhy::GetPhyRateFromTxVector(const WifiTxVector& txVector, uint16_t staId /* = SU_STA_ID */)
 {
-    uint16_t bw = txVector.GetChannelWidth();
+    auto bw = txVector.GetChannelWidth();
     if (txVector.IsMu())
     {
         bw = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
@@ -1662,7 +1686,7 @@
 uint64_t
 HePhy::GetDataRateFromTxVector(const WifiTxVector& txVector, uint16_t staId /* = SU_STA_ID */)
 {
-    uint16_t bw = txVector.GetChannelWidth();
+    auto bw = txVector.GetChannelWidth();
     if (txVector.IsMu())
     {
         bw = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
@@ -1674,11 +1698,12 @@
 }
 
 uint64_t
-HePhy::GetDataRate(uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+HePhy::GetDataRate(uint8_t mcsValue, MHz_u channelWidth, Time guardInterval, uint8_t nss)
 {
-    NS_ASSERT(guardInterval == 800 || guardInterval == 1600 || guardInterval == 3200);
+    [[maybe_unused]] const auto gi = guardInterval.GetNanoSeconds();
+    NS_ASSERT((gi == 800) || (gi == 1600) || (gi == 3200));
     NS_ASSERT(nss <= 8);
-    return HtPhy::CalculateDataRate(GetSymbolDuration(NanoSeconds(guardInterval)),
+    return HtPhy::CalculateDataRate(GetSymbolDuration(guardInterval),
                                     GetUsableSubcarriers(channelWidth),
                                     static_cast<uint16_t>(log2(GetConstellationSize(mcsValue))),
                                     HtPhy::GetCodeRatio(GetCodeRate(mcsValue)),
@@ -1686,9 +1711,9 @@
 }
 
 uint16_t
-HePhy::GetUsableSubcarriers(uint16_t channelWidth)
+HePhy::GetUsableSubcarriers(MHz_u channelWidth)
 {
-    switch (channelWidth)
+    switch (static_cast<uint16_t>(channelWidth))
     {
     case 2: // 26-tone RU
         return 24;
@@ -1717,8 +1742,8 @@
 uint64_t
 HePhy::GetNonHtReferenceRate(uint8_t mcsValue)
 {
-    WifiCodeRate codeRate = GetCodeRate(mcsValue);
-    uint16_t constellationSize = GetConstellationSize(mcsValue);
+    const auto codeRate = GetCodeRate(mcsValue);
+    const auto constellationSize = GetConstellationSize(mcsValue);
     return CalculateNonHtReferenceRate(codeRate, constellationSize);
 }
 
@@ -1816,18 +1841,29 @@
     return VhtPhy::GetRxPpduFromTxPpdu(ppdu);
 }
 
-WifiSpectrumBandIndices
-HePhy::ConvertHeRuSubcarriers(uint16_t bandWidth,
-                              uint16_t guardBandwidth,
-                              uint32_t subcarrierSpacing,
+std::vector<WifiSpectrumBandIndices>
+HePhy::ConvertHeRuSubcarriers(MHz_u bandWidth,
+                              MHz_u guardBandwidth,
+                              const std::vector<MHz_u>& centerFrequencies,
+                              MHz_u totalWidth,
+                              Hz_u subcarrierSpacing,
                               HeRu::SubcarrierRange subcarrierRange,
                               uint8_t bandIndex)
 {
-    WifiSpectrumBandIndices convertedSubcarriers;
-    auto nGuardBands =
+    NS_ASSERT_MSG(bandWidth <= totalWidth,
+                  "Bandwidth (" << bandWidth << ") cannot exceed total operating channel width ("
+                                << totalWidth << ")");
+    std::vector<WifiSpectrumBandIndices> convertedSubcarriers{};
+    guardBandwidth /= centerFrequencies.size();
+    const auto nGuardBands =
         static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / subcarrierSpacing) + 0.5);
+    if (bandWidth > (totalWidth / centerFrequencies.size()))
+    {
+        NS_ASSERT(bandIndex == 0);
+        bandWidth /= centerFrequencies.size();
+    }
     uint32_t centerFrequencyIndex = 0;
-    switch (bandWidth)
+    switch (static_cast<uint16_t>(bandWidth))
     {
     case 20:
         centerFrequencyIndex = (nGuardBands / 2) + 6 + 122;
